# Version options
%define kernel_base_version 2.4.22
%define kernel_extra_version	%nil
# Numeric extra version scheme developed by Alexander Bokovoy:
# 0.0.X -- preX
# 0.X.0 -- rcX
# 1.0.0 -- release
%define kernel_extra_version_numeric 1.0.0
%define krelease alt1
%define flavour uml

# Build options
# You can change compiler by editing and uncommenting this line:
#define kgcc gcc-3.2

# Fixes:
%add_patch_list kernel-fix-build

%add_patch_list kernel-fix-security-owl
#add_patch_list kernel-fix-security

%add_patch_list kernel-fix-net
%add_patch_list kernel-fix-core 
%add_patch_list kernel-fix-fs

%add_patch_list kernel-fix-drivers-ide
%add_patch_list kernel-fix-drivers-net
%add_patch_list kernel-fix-drivers-pci
%add_patch_list kernel-fix-drivers-scsi 
%add_patch_list kernel-fix-drivers-sound 
%add_patch_list kernel-fix-drivers-usb
%add_patch_list kernel-fix-drivers-char
%add_patch_list kernel-fix-drivers-md
%add_patch_list kernel-fix-drivers-mtd
%add_patch_list kernel-fix-drivers-video
%add_patch_list kernel-fix-drivers-ieee1394
%add_patch_list kernel-fix-drivers-atm


##################
%add_patch_list kernel-feat-fs-xfs
%add_patch_list kernel-feat-acpi
#add_patch_list kernel-feat-core-O1sched
%add_patch_list kernel-feat-addon
%add_patch_list kernel-feat-bttv
%add_patch_list kernel-feat-i2c kernel-feat-fs-ntfs
%add_patch_list kernel-feat-kconfig
%add_patch_list kernel-feat-crypto
%add_patch_list kernel-feat-drivers-usb
%add_patch_list kernel-feat-drivers-block-enbd
#add_patch_list kernel-feat-drivers-pktcdvd
%add_patch_list kernel-feat-drivers-video-splash
%add_patch_list kernel-feat-net-ppp-mppe
%add_patch_list kernel-feat-net-ipsec
%add_patch_list kernel-feat-drivers-media-v4l2
%add_patch_list kernel-feat-saa7134
%add_patch_list	kernel-feat-drivers-net-sk98lin
%add_patch_list	kernel-feat-drivers-sound-emu10k1
%add_patch_list kernel-feat-uml

%add_patch_list kernel-fix-drivers-media

## Don't edit below this line ##################################

%define	kversion %{kernel_base_version}

%{?__ccache_cc: %define _disable_ccache 1}

%if_enabled ccache
%define kcc "ccache %kgcc"
%else
%define kcc "%kgcc"
%endif

%ifdef use_ccache
%define kcc "ccache %kgcc"
%else
%define kcc "%kgcc"
%endif

Name: user-mode-linux-%{flavour}
Version: %{kversion}
Release: %{krelease}

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: Emulators
Url: http://user-mode-linux.sourceforge.net/
Packager: Andrey Khavryuchenko <akhavr@altlinux.ru>

Source1: config-%{kversion}-%{flavour}
Source2: uml_utilities_20030903.tar.bz2

ExclusiveOS: Linux
ExclusiveArch:	%{ix86}

BuildRequires: coreutils libdb4.0-devel perl flex dev86
BuildRequires: rpm >= 4.0.2-75
BuildRequires: kernel-source-%{kernel_base_version} = %{kernel_extra_version_numeric}
BuildRequires: kernel-build-tools
BuildRequires: %get_patch_list
BuildRequires: %(echo %kgcc | sed -e "s/-//")
BuildRequires: kernel-fix-core >= 2003.06.11
BuildRequires: glibc-devel-static
BuildRequires: libncurses-devel

BuildRequires: libreadline-devel

%if_enabled ccache
BuildRequires: ccache
%endif

%ifdef use_ccache
BuildRequires: ccache
%endif

%description
User-Mode Linux is a safe, secure way of running Linux versions and
Linux processes. Run buggy software, experiment with new Linux kernels
or distributions, and poke around in the internals of Linux, all
without risking your main Linux setup.

User-Mode Linux gives you a virtual machine that may have more
hardware and software virtual resources than your actual, physical
computer. Disk storage for the virtual machine is entirely contained
inside a single file on your physical machine. You can assign your
virtual machine only the hardware access you want it to have. With
properly limited access, nothing you do on the virtual machine can
change or damage your real computer, or its software.

Patches included:%format_patch_list


%prep

%setup -cT -n user-mode-linux-%flavour-%kversion-%krelease
%__rm -rf kernel-source-%{kernel_base_version}
%__tar -jxf %kernel_src/kernel-source-%{kernel_base_version}.tar.bz2

%__tar -jxf %{SOURCE2}

%setup -D -T -n user-mode-linux-%flavour-%kversion-%krelease/kernel-source-%{kernel_base_version}

echo "patches = %_patch_list"

%apply_patches

%__mv -f Makefile Makefile.orig
%__sed -e 's/EXTRAVERSION =.*/EXTRAVERSION =/g' \
    -e 's/CC.*$(CROSS_COMPILE)gcc/CC		= %{kgcc}/g' \
    Makefile.orig >Makefile



%build

KERNEL_BUILD_DIR=`pwd`
KernelVer=%{kversion}-%{flavour}-%{krelease}

echo "Building Kernel $KernelVer"

:> arch/%{base_arch}/defconfig

%__cat %{SOURCE1} >> arch/um/defconfig
%make_build mrproper CC=%kcc EXTRAVERSION=%kernel_extra_version-%{flavour}-%{krelease} ARCH=um
%make_build oldconfig CC=%kcc EXTRAVERSION=%kernel_extra_version-%{flavour}-%{krelease} ARCH=um

### It's a hack, but a useful hack:

cmp -s .config %SOURCE1 || %__cp -vf .config %SOURCE1

NPROCS=1; %make_build dep clean CC=%kcc EXTRAVERSION=%kernel_extra_version-%{flavour}-%{krelease} ARCH=um
NPROCS=1; %make_build include/linux/version.h CC=%kcc EXTRAVERSION=%kernel_extra_version-%{flavour}-%{krelease} ARCH=um

NPROCS=1; %make_build linux CC=%kcc EXTRAVERSION=%kernel_extra_version-%{flavour}-%{krelease} ARCH=um

strip linux

echo "Kernel built $KernelVer"

cd ../tools
make
cd ..

%install
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 755 linux $RPM_BUILD_ROOT/usr/bin
cd ../tools
make DESTDIR=$RPM_BUILD_ROOT install


%files
%defattr(755,root,root)
/usr/bin/jailtest
/usr/bin/linux
/usr/bin/tunctl
/usr/bin/uml_mconsole
/usr/bin/uml_mkcow
/usr/bin/uml_moo
/usr/bin/uml_net
/usr/bin/uml_switch
/usr/bin/uml_watchdog
/usr/lib/uml/port-helper

%changelog
* Wed Oct 8 2003 Andrey Khavryuchenko <akhavr@altlinux.ru> 2.4.22-alt1
- intial build based on kernel-std-up.spec 2.4.22-alt5
